import { useCallback, useRef } from "react";

export default function useTag(inited, tags, setTags) {
  const getNewTag = useRef()
  getNewTag.current = (tag) => {
    const matched = tags.filter((item) => (tag.name === item.name))[0]

    if (matched && matched.id) {
      return matched
    }

    return tag
  }

  const updateTags = useCallback((nwTags) => {
    if (!nwTags || !nwTags.length) {
      return tags
    }

    const nwVals = nwTags.map((tag) => getNewTag.current(tag))
    setTags(nwVals)
    inited.current = true
  }, [tags])

  const appendTags = useCallback((tag) => {
    const found = tags.filter((item) => (tag.name === item.name))[0]
    if (found) {
      return
    }

    setTags(tags.concat(tag))
    inited.current = true
  }, [tags])


  const deleteTags = useCallback((tag) => {
    const nwVal = tags.filter((it) => it.name !== tag.name)
    
    setTags(nwVal)
  }, [tags])

  return [updateTags, appendTags, deleteTags]
}
