import { useEffect, useRef } from "react"

export default function useValue(value, poiRef, updateTags) {
  const valueInited = useRef(false)

  useEffect(() => {
    if (!valueInited.current && value) {
      const vals = value.split(',').filter(Boolean).map((tag) => ({ name: tag }))
      const newTags = !poiRef.length ? vals : vals.map((val) => {
        const found = poiRef.current.filter((poi) => poi.name === val.name)[0]
        return found || val
      })
      updateTags(newTags)
      valueInited.current = true
    }
  }, [value])
}
